#include <wx/valgen.h>

#include "gui/ElementDialog.h"
#include "ProjectBase.h"

// constructor and destructor ////////////////////////////////////////////////////////////////

udElementDialog::udElementDialog(wxWindow *parent, udLanguage *lang) : _ElementDialog( parent )
{
	m_pLang = lang;
}

udElementDialog::~udElementDialog()
{
}

// virtual functions /////////////////////////////////////////////////////////////////////////

void udElementDialog::OnInit(wxInitDialogEvent& event)
{
	// set validators
	m_eName->SetValidator(wxGenericValidator(&m_Name));
	m_eDescription->SetValidator(wxGenericValidator(&m_Description));
	
	// use validators to transfer a data
	TransferDataToWindow();
}

void udElementDialog::OnNameChange(wxCommandEvent& event)
{
	if( ( m_Name != m_eName->GetValue() ) && m_cbMakeValid->GetValue() && m_pLang)
	{
		long nFrom, nTo;
		m_eName->GetSelection(&nFrom, &nTo);
		
		m_eName->ChangeValue( m_pLang->MakeValidIdentifier( m_eName->GetValue() ) );
		
		m_eName->SetSelection( nFrom, nTo );
	}
}

void udElementDialog::OnMakeValid(wxCommandEvent& event)
{
	OnNameChange( event );
}

void udElementDialog::OnOk(wxCommandEvent& event)
{
	if( m_eName->GetValue() == wxT("") )
	{
		wxMessageBox(wxT("Name cannot be empty."), wxT("CodeDesigner"), wxICON_WARNING | wxOK );
		m_eName->SetFocus();
	}
//	else if( (m_Name != m_eName->GetValue()) && !IPluginManager::Get()->GetProject()->IsUniqueName( m_eName->GetValue() ) )
//	{
//		wxMessageBox(wxT("Name must be unique."), wxT("CodeDesigner"), wxICON_WARNING | wxOK );
//		m_eName->SetFocus();		
//	}
	else
	{
		// get data via validators...
		TransferDataFromWindow();
		
		EndModal( wxID_OK );
	}
}
